/* This file was generated by mib2c and is intended for use as a mib module
   for the ucd-snmp snmpd agent. */

/* This should always be included first before anything else */
//#include <config.h> 

#ifdef IN_UCD_SNMP_SOURCE
/* If we're compiling this file inside the ucd-snmp source tree */


///* This should always be included first before anything else */
//#include <config.h>


/* minimal include directives */
#include "mibincl.h"
#include "util_funcs.h"


#else /* !IN_UCD_SNMP_SOURCE */


//#include <ucd-snmp/ucd-snmp-config.h>
//#include <ucd-snmp/ucd-snmp-includes.h>
//#include <ucd-snmp/ucd-snmp-agent-includes.h>
#include <ucd-snmp-config.h>
#include <ucd-snmp-includes.h>
#include <ucd-snmp-agent-includes.h>


#endif /* !IN_UCD_SNMP_SOURCE */


#include "powerMIB.h"

#include "snmp_public.h"

//#define MANUFACTURER_MODEL "M810G"
#define MANUFACTURER_MODEL "NCU"

/*#define __SUPPORT_ACU_MIB*/
/*All the modification for SCU+ mib, by Hulongwen Jan.17,2007*/
/*Just delete some mib nods of ACU MIB*/


//Siganl set time out
#define SET_TIME_OUT	6000 //6s

/* 
* powerMIB_variables_oid:
*   this is the top level oid that we want to register under.  This
*   is essentially a prefix, with the suffix appearing in the
*   variable below.
*/


oid powerMIB_variables_oid[] = { 1,3,6,1,4,1,6302,2,1 };


/* 
* variable4 powerMIB_variables:
*   this variable defines function callbacks and type return information 
*   for the powerMIB mib section 
*/
typedef struct variable8 VAR8_SNMP;

struct tagNodItem
{
	int			iVarIndex; //映射powerVar
	int			iSigItemIndex;//映射SigItem
};
typedef struct tagNodItem SNMP_NOD_INFO;

/*    (L = length of the oidsuffix) */
VAR8_SNMP* pPowerMIB_variables;
SNMP_NOD_INFO* gpNodInfos;
SNMP_INFO_STRUCT* pSnmpInfoStru;
/*
* init_powerMIB():
*   Initialization routine.  This is called when the agent starts up.
*   At a minimum, registration of your variables should take place here.
*/
static SNMP_TABLE_ITEM_INFO* GetTableInfo_FromID(int iTableID)
{
	int i = 0;
	for(i =0; i < pSnmpInfoStru->nSnmpTableNum; i++)
	{
		if(pSnmpInfoStru->pSnmpTableInfos[i].nTableID = iTableID)
		{
			return &(pSnmpInfoStru->pSnmpTableInfos[i]);
		}
	}
	return NULL;
}
static int GetNodVarTypeFromNod(SNMP_SIG_ITEM_INFO* pNodInfo)
{
	int nType = ASN_OCTET_STR;
	switch(pNodInfo->nValueType)
	{
	case SNMP_VT_INT:
	case SNMP_VT_FLOAT:
	case SNMP_VT_INDEX:
	case SNMP_VT_ALARMLEVEL:
	case SNMP_VT_ALARMTYPE:
	case SNMP_VT_ALARMSTCHANGE:
		nType = ASN_INTEGER;
		break;
	case SNMP_VT_ALARMLASTNO:
		nType = ASN_COUNTER;
		break;
	default:
		break;
	}
	//added by Jimmy 2014.9.1 for EMEA 
	if(pNodInfo->nValueType == SNMP_VT_INDEX 
		&& (pNodInfo->pTableInfo != NULL))
	{
		if(pNodInfo->pTableInfo->nEquipTypeNums == -1)//ALARM
		{
			nType = ASN_COUNTER;
		}
	}
	return nType;
}

static BOOL Is2OidEqual(VAR8_SNMP* pVar1,VAR8_SNMP* pVar2)
{
	if(pVar1->namelen != pVar2->namelen)
	{
		return FALSE;
	}
	int i = 0;
	for(;i < pVar1->namelen; i++)
	{
		if(pVar1->name[i] != pVar2->name[i])
		{
			return FALSE;
		}
	}
	return TRUE;
}
void init_powerMIB(void) 
{
	int i = 0;
	int j = 0;
	int iLen = 0;
	pSnmpInfoStru = GetSnmpInfoRef();
	int iTotal = pSnmpInfoStru->nSnmpSigNum;
	if(iTotal <= 0)
	{
		return;
	}
	VAR8_SNMP* pVar8s_Tmp = NEW(VAR8_SNMP,iTotal);
	SNMP_NOD_INFO* pNos_Tmp = NEW(SNMP_NOD_INFO,iTotal);
	if(pVar8s_Tmp == NULL || pNos_Tmp == NULL)
	{
		return;
	}
	//Initial the mib nods(signals)	
	SNMP_SIG_ITEM_INFO* pSigInfo = pSnmpInfoStru->pSnmpSigInfos;
	for(i = 0; i < iTotal; i++,pSigInfo++)
	{
		pVar8s_Tmp[i].acl = pSigInfo->nAccessAttr;
		pVar8s_Tmp[i].type = GetNodVarTypeFromNod(pSigInfo);
		pVar8s_Tmp[i].namelen = pSigInfo->oid_this.iLenth;
		memcpy(pVar8s_Tmp[i].name,pSigInfo->oid_this._oids,MAX_SNMP_OID_LENTH*sizeof(oid));
		pVar8s_Tmp[i].magic = 0;
		if(pSigInfo->pTableInfo != NULL)//has table
		{
			pVar8s_Tmp[i].findVar = var_tableItem;
		}
		else
		{
			pVar8s_Tmp[i].findVar = var_seperatedItem;
		}

		pNos_Tmp[i].iSigItemIndex = i;
		//pNos_Tmp[k].iVarIndex = k;
	}
	//remove the repeated nods
	iLen = iTotal;
#define UNUSED_MAGIC	255			//255不用
	for(i = 0; i < iTotal; i++)
	{
		//printf("\n+++++++ %d.%d.%d.%d.%d",pVar8s_Tmp[i].name[0],pVar8s_Tmp[i].name[1],pVar8s_Tmp[i].name[2],pVar8s_Tmp[i].name[3],pVar8s_Tmp[i].name[4]);
		for(j = i + 1; j < iTotal; j++)
		{
			if(Is2OidEqual(&pVar8s_Tmp[i], &pVar8s_Tmp[j]))
			{
				iLen--;
				pVar8s_Tmp[j].magic = UNUSED_MAGIC;
				break;
			}
		}
	}
	if(iLen <= 0)
	{
		AppLogOut(SNMP_UI_TASK, APP_LOG_ERROR,
			"Fails on calling the ini_PowerMib function.");
		//snmp配置告警
		SetDwordSigValue(1, SIG_TYPE_SAMPLING, 195, 1, "SNMP set Config Error Alarm");
		return;
	}
	if(iLen >= 255)
	{
		iLen = 255; //最大255个，因为magic是uchar类型的
		//snmp配置告警
		SetDwordSigValue(1, SIG_TYPE_SAMPLING, 195, 1, "SNMP set Config Error Alarm");
	}
	//fill in the Power_Var finally
	pPowerMIB_variables = NEW(VAR8_SNMP,iLen);
	gpNodInfos = NEW(SNMP_NOD_INFO,iLen);
	if(pPowerMIB_variables == NULL || gpNodInfos == NULL)
	{
		AppLogOut(SNMP_UI_TASK, APP_LOG_ERROR,
			"Fails on calling the ini_PowerMib function.");
		return;
	}
	for(i =0, j = 0; (i < iTotal) && (j < iLen); i++) //cfg文件定义的nods必须按先后顺序，否则getnext会有问题，可参见snmp源码的serch??subtree函数
	{
		if(pVar8s_Tmp[i].magic != UNUSED_MAGIC)
		{
			pPowerMIB_variables[j].acl		= pVar8s_Tmp[i].acl;
			pPowerMIB_variables[j].findVar	= pVar8s_Tmp[i].findVar;
			pPowerMIB_variables[j].magic	= j + 1;
			memcpy(pPowerMIB_variables[j].name,pVar8s_Tmp[i].name,MAX_SNMP_OID_LENTH*sizeof(oid));
			pPowerMIB_variables[j].namelen	= pVar8s_Tmp[i].namelen;
			pPowerMIB_variables[j].type		= pVar8s_Tmp[i].type;
			//create nod info, just for indexing
			gpNodInfos[j].iSigItemIndex = pNos_Tmp[i].iSigItemIndex;
			gpNodInfos[j].iVarIndex = j;
			j++;
		}
	}
	DELETE(pVar8s_Tmp);
	DELETE(pNos_Tmp);
	if(j != iLen)
	{
		printf("\n Error:::Not match the initial mib sig number!!!\n");
		AppLogOut(SNMP_UI_TASK, APP_LOG_ERROR,
			"Fails on calling the ini_PowerMib function.");
		//snmp配置告警
		SetDwordSigValue(1, SIG_TYPE_SAMPLING, 195, 1, "SNMP set Config Error Alarm");
		return;
	}
	pSnmpInfoStru->nNodNum = iLen;

	//Jimmy注释：这里修改了原来定义的REGISTER_MIB宏，用iLen参数替代原有的，请注意区别
#define ___REGISTER_MIB(descr, var, vartype, theoid)                      \
	(register_mib(descr, (struct variable *) var, sizeof(struct vartype), \
	/*sizeof(var)/sizeof(struct vartype)*/ iLen,                     \
	theoid, sizeof(theoid)/sizeof(oid)))
	/* register ourselves with the agent to handle our mib tree */
	int iRet = ___REGISTER_MIB("powerMIB", pPowerMIB_variables, variable8,
		powerMIB_variables_oid);

#ifdef _SNMP_TEST_M	
	printf("\n--Jimmy the regMid ret = %d", iRet);
	printf("\n---------------------------------Jimmy, iniVar_PowerMib OK!, iTotal = %d, the NodNum = %d",iTotal,pSnmpInfoStru->nNodNum);
	for(i = 0; i < iLen; i++)
	{
		printf("\n%d.%d.%d.%d.%d\t %d \t %d \t%d \t%d",pPowerMIB_variables[i].name[0],
			pPowerMIB_variables[i].name[1],
			pPowerMIB_variables[i].name[2],
			pPowerMIB_variables[i].name[3],
			pPowerMIB_variables[i].name[4],
			pPowerMIB_variables[i].namelen,
			pPowerMIB_variables[i].magic,
			pPowerMIB_variables[i].type,
			pPowerMIB_variables[i].acl);
		if(pPowerMIB_variables[i].findVar == var_seperatedItem)
		{
			printf("\tvar_seperatedItem");
		}
		else if(pPowerMIB_variables[i].findVar == var_tableItem)
		{
			printf("\tvar_tableItem");
		}
	}
	printf("\n--------------the Index arr struct Info 0-----------------");
	for(i = 0; i < iLen; i++)
	{
		printf("\n SigIdx: %d, VarIdx = %d",gpNodInfos[i].iSigItemIndex,gpNodInfos[i].iVarIndex);
	}
	printf("\n");
#endif
}
enum sigValRetType
{
	_RTYPE_CHAR = 1,
	_RTYPE_INT,
	_RTYPE_ERR = -1,
};
static int				s_nActiveAlarmNum = 0;
static ALARM_SIG_VALUE* s_pActiveAlarmSigValue = NULL;
static int GetAlarmLevelRet(void)
{
	int				nAlarmLevelRet = ALARM_LEVEL_NONE;
	int				nCurAlarmLevel;

	int				nActiveAlarmNum = 0;
	ALARM_SIG_VALUE* pActiveAlarmSigValue = NULL;
	ALARM_SIG_VALUE* pAlarmSigValue = NULL;

	if (DXI_GetActiveAlarmItems(&nActiveAlarmNum, 
		&pActiveAlarmSigValue)
		== ERR_DXI_OK)
	{
		int i;

		pAlarmSigValue = pActiveAlarmSigValue;

		for (i = 0; i < nActiveAlarmNum; i++, pActiveAlarmSigValue++)
		{
			nCurAlarmLevel = pActiveAlarmSigValue->pStdSig->iAlarmLevel;

			if (nCurAlarmLevel > nAlarmLevelRet
				&& nCurAlarmLevel <= ALARM_LEVEL_CRITICAL)
			{
				nAlarmLevelRet = nCurAlarmLevel;

				if (nAlarmLevelRet == ALARM_LEVEL_CRITICAL)
				{
					break;
				}
			}			
		}

	}

	DELETE_ITEM(pAlarmSigValue);

	return nAlarmLevelRet;
}

static int HandleSpecialVal(int iValSrc,SNMP_SIG_ITEM_INFO *pItInfo)
{
	int iRet = iValSrc;
	long lUniqID = DXI_MERGE_UNIQUE_SIG_ID(pItInfo->nStdEquipID,pItInfo->nSigType,pItInfo->nSigID);
	if(lUniqID == DXI_MERGE_UNIQUE_SIG_ID(100,0,20))//system status
	{
		if (iValSrc== 0)//Normal
		{
			iRet = SYSTEM_STATUS_NORMAL;

		}
		else if (iValSrc == 1)//have alarm
		{
			int nAlarmLevelRet = GetAlarmLevelRet();

			if (nAlarmLevelRet == ALARM_LEVEL_CRITICAL)
			{
				iRet = SYSTEM_STATUS_CRITICAL;
			}
			else if (nAlarmLevelRet == ALARM_LEVEL_MAJOR)
			{
				iRet = SYSTEM_STATUS_MAJOR;
			}
			else if (nAlarmLevelRet == ALARM_LEVEL_OBSERVATION)
			{
				iRet = SYSTEM_STATUS_WARNING;
			}
		}
	}
	else if(lUniqID == DXI_MERGE_UNIQUE_SIG_ID(100,3,2))//psCAN comm status
	{
		if (iValSrc == 1) //Can comm interrupt, because it has alarm
		{
			iRet = PS_COMMUNICATION_INTERRUPT;
		}
		else if (iValSrc == 0)
		{
			iRet = PS_COMMUNICATION_NORMAL;
		}
		else
		{
			iRet = PS_COMMUNICATION_UNKNOWN;
		}
	}
	else if(lUniqID == DXI_MERGE_UNIQUE_SIG_ID(300,0,25))//ps Battery Mode
	{
		iRet = iRet + 2;
	}
	else if(lUniqID == DXI_MERGE_UNIQUE_SIG_ID(201,0,80) || 
		lUniqID == DXI_MERGE_UNIQUE_SIG_ID(1601,0,80) || 
		lUniqID == DXI_MERGE_UNIQUE_SIG_ID(1701,0,80) || 
		lUniqID == DXI_MERGE_UNIQUE_SIG_ID(1801,0,80) ||
		lUniqID == DXI_MERGE_UNIQUE_SIG_ID(1101,0,80))
	{
		iRet = (iRet > 0)?ALARM_STATUS_ACTIVATED:ALARM_STATUS_DEACTIVATED;
	}
	//else if(pItInfo->nStdEquipID >= 2201 && pItInfo->nStdEquipID <= 2208 && 
	//	pItInfo->nSigType == 2 &&
	//	pItInfo->nSigID >= 1 && pItInfo->nSigID <= 8) //SMTEMP Temp Type
	//{
	//	iRet = (iRet >= 1) ? (iRet - 1) : 2;
	//}
	//else if(pItInfo->nStdEquipID == 100 && pItInfo->nSigType == 2 &&
	//	((pItInfo->nSigID >= 50 && pItInfo->nSigID <= 54) || 
	//	pItInfo->nSigID == 78 || pItInfo->nSigID == 79)) //SMTEMP Temp Type
	//{
	//	iRet = (iRet >= 1) ? (iRet - 1) : 2;
	//}
	else if(pItInfo->nSigType == 3)//对一般告警均这么处理
	{
		iRet = (iRet > 0)?ALARM_STATUS_ACTIVATED:ALARM_STATUS_DEACTIVATED;
	}
	return iRet;
}

static BOOL GetProductInfo_OutStr(int iEquipID,int iInfoType,OUT char* pSzOutstr)
{
	PRODUCT_INFO sProductInfo;
	PRODUCT_INFO* pProductInfo = NULL;
	int nFirstRectID = DXI_GetFirstRectDeviceID();
	//Power System
	if(iEquipID == 1)
	{
		pProductInfo = DXI_GetDeviceProductInfo();
	}
	else if(iEquipID >= 3 && iEquipID <= 102)
	{
		//DXI_GetPIByDeviceID(iEquipID - 1, &sProductInfo);
		//pProductInfo = &sProductInfo;
		//First 100 rectifiers
		//printf("\n---EID:%d, First 100 Rects!",iEquipID);
		pProductInfo = g_SiteInfo.stCANRectProductInfo + iEquipID - 3;
	}
	else if(iEquipID >= 1601 && iEquipID <= 1620)
	{
		//Rest 20 rectifiers
		//printf("\n---EID:%d, Rest 20 Rects!",iEquipID);
		pProductInfo = g_SiteInfo.stCANRectProductInfo + iEquipID - 1601 + 100;
	}
	else if(iEquipID >= 339 && iEquipID < 439)//Slave1 Rectifiers
	{
		DXI_GetPIByDeviceID(nFirstRectID + 110 + 20 + iEquipID - 339, &sProductInfo);
		pProductInfo = &sProductInfo;
	}
	else if(iEquipID >= 439 && iEquipID < 539)//Slave2 Rectifiers
	{
		DXI_GetPIByDeviceID(nFirstRectID + 170 + 20 + iEquipID - 439, &sProductInfo);
		pProductInfo = &sProductInfo;
	}
	else if(iEquipID >= 539 && iEquipID < 639)//Slave3 Rectifiers
	{
		DXI_GetPIByDeviceID(nFirstRectID + 230 + 20 + iEquipID - 539, &sProductInfo);
		pProductInfo = &sProductInfo;
	}
	////I2C Devices
	//else if((iEquipID >= nFirstRectID + 290) && (nDeviceId < nFirstRectID + 298))
	//{
	//	pProductInfo = g_SiteInfo.stI2CProductInfo + (nDeviceId - nFirstRectID - 290);
	//}
	//else if((nDeviceId >= nFirstRectID + 298) && (nDeviceId < nFirstRectID + 306))
	//{
	//	pProductInfo = g_SiteInfo.stCANSMDUPProductInfo + (nDeviceId - nFirstRectID - 298);
	//}
	////Rs485
	//else if((nDeviceId >= nFirstRectID + 306) && (nDeviceId < nFirstRectID + 368))
	//{

	//	pProductInfo = g_SiteInfo.st485ProductInfo + (nDeviceId - nFirstRectID - 306);
	//}
	//Convertor
	else if((iEquipID >= 211 && iEquipID <= 258) ||
		(iEquipID >= 1400 && iEquipID <= 1411))
	{
		if(iEquipID < 1400)
		{
			pProductInfo = g_SiteInfo.stCANConverterProductInfo + (iEquipID - 211);//1~48
		}
		else
		{
			pProductInfo = g_SiteInfo.stCANConverterProductInfo + (iEquipID  + 48 - 1400);//49~60
		}
		
	}
	//SM Temp added by Jimmy 2011/10/26
	//else if(nDeviceId >= nFirstRectID + 428 && nDeviceId < nFirstRectID + 436)
	//{
	//	pProductInfo = g_SiteInfo.stCANSMTempProductInfo + (nDeviceId - nFirstRectID - 428);
	//}
	////Li Batt added by Jimmy 2012/04/01
	//else if(nDeviceId >= nFirstRectID + 436 && nDeviceId < nFirstRectID + 496)
	//{
	//	pProductInfo = g_SiteInfo.stCANLiBattProductInfo + (nDeviceId - nFirstRectID - 436);
	//}

	else if(iEquipID >= 1351 && iEquipID <= 1380)
	{
		pProductInfo = g_SiteInfo.stCANMpptProductInfo + (iEquipID - 1351);
	}


	if(!pProductInfo)
	{
		return FALSE;
	}


	switch(iInfoType)
	{
	case SNMP_VT_PRDCT_NUM:
		if(pProductInfo->szPartNumber[0]!='\0')
		{
			strncpy(pSzOutstr, pProductInfo->szPartNumber, 16);
		}
		else
		{
			strcpy(pSzOutstr, "N/A");
		}

		break;

	case SNMP_VT_HW_VER:
		if(pProductInfo->szHWVersion[0]!='\0')
		{
			strncpy(pSzOutstr, pProductInfo->szHWVersion, 16);
		}
		else
		{
			strcpy(pSzOutstr, "N/A");
		}

		break;

	case SNMP_VT_SW_VER:
		if(pProductInfo->szSWVersion[0]!='\0')
		{
			strncpy(pSzOutstr, pProductInfo->szSWVersion, 16);
		}
		else
		{
			strcpy(pSzOutstr, "N/A");
		}

		break;

	case SNMP_VT_SERIAL_NUM:
		if(pProductInfo->szSerialNumber[0]!='\0')
		{
			strncpy(pSzOutstr, pProductInfo->szSerialNumber, 16);
		}
		else
		{
			strcpy(pSzOutstr, "N/A");
		}
		break;

	default:
		strcpy(pSzOutstr, "N/A");
		break;

	}


	return TRUE;
}

static int GetAnItemValue(IN int iIndex,IN SNMP_SIG_ITEM_INFO *pItInfo,IN int iEquipID,OUT char* pStrVal, OUT long* pLVar)
{
	int nError, nBufLen;
	EQUIP_INFO*	pEquipInfo;
	VOID			*pSigInfo;
	SAMPLE_SIG_INFO	*pSamSigInfo;
	CTRL_SIG_INFO	*pCtrlSigInfo;
	SET_SIG_INFO	*pSetSigInfo;
	ALARM_SIG_INFO	*pAlmSigInfo;
	SIG_BASIC_VALUE* pSigValue = NULL;
	LANG_TEXT* pSiteLangText;
	DWORD dwVersion;
	//BOOL bNeedEquipNameforSig = (pItInfo->pTableInfo->bIsEquipType == FALSE);
	int iRetType = _RTYPE_ERR;
	ACU_PRODUCT_INFO sAcuProductInfo;


	//printf("\n0000000000000Jimmy, the to be got item value type = %d\n", pItInfo->nValueType);
	switch(pItInfo->nValueType)
	{
	case SNMP_VT_SNMP_CFGVER:
		if(pSnmpInfoStru->nSnmpPriCfgNum > 0)// return the last change
		{
			strcpy(pStrVal, pSnmpInfoStru->pSnmpPriCfgInfos[pSnmpInfoStru->nSnmpPriCfgNum - 1].szSNMPpriCfgVer);
		}
		iRetType = _RTYPE_CHAR;
		break;

	case SNMP_VT_EQUIP_NAME:
		nError = DxiGetData(VAR_A_EQUIP_INFO,
			iEquipID,			
			0,		
			&nBufLen,			
			&pEquipInfo,			
			0);
		if (nError != ERR_DXI_OK)
		{
			return _RTYPE_ERR;
		}
		sprintf(pStrVal,"%s",pEquipInfo->pEquipName->pFullName[0]);//use English full name
		iRetType = _RTYPE_CHAR;
		break;

	case SNMP_VT_SIGNAL_NAME:
		nError = DxiGetData(VAR_A_SIGNAL_INFO_STRU,
			iEquipID,			
			DXI_MERGE_SIG_ID(pItInfo->nSigType, pItInfo->nSigID),
			&nBufLen,			
			&pSigInfo,			
			0);
		if (nError != ERR_DXI_OK)
		{
			return _RTYPE_ERR;
		}
		if(pItInfo->nSigType == SIG_TYPE_SAMPLING)
		{
			pSamSigInfo = (SAMPLE_SIG_INFO*)pSigInfo;
			sprintf(pStrVal,"%s",pSamSigInfo->pSigName->pFullName[0]);//use English full name
		}
		else if(pItInfo->nSigType == SIG_TYPE_CONTROL)
		{
			pCtrlSigInfo = (CTRL_SIG_INFO*)pSigInfo;
			sprintf(pStrVal,"%s",pCtrlSigInfo->pSigName->pFullName[0]);//use English full name
		}
		else if(pItInfo->nSigType == SIG_TYPE_SETTING)
		{
			pSetSigInfo = (SET_SIG_INFO*)pSigInfo;
			sprintf(pStrVal,"%s",pSetSigInfo->pSigName->pFullName[0]);//use English full name
		}
		else if(pItInfo->nSigType == SIG_TYPE_ALARM)
		{
			pAlmSigInfo = (ALARM_SIG_INFO*)pSigInfo;
			sprintf(pStrVal,"%s",pAlmSigInfo->pSigName->pFullName[0]);//use English full name
		}
		//if(bNeedEquipNameforSig)
		//{
		//	nError = DxiGetData(VAR_A_EQUIP_INFO,
		//		iEquipID,			
		//		0,		
		//		&nBufLen,			
		//		&pEquipInfo,			
		//		0);
		//	if (nError != ERR_DXI_OK)
		//	{
		//		return _RTYPE_ERR;
		//	}
		//	strcat(pStrVal," owner ");
		//	strcat(pStrVal,pEquipInfo->pEquipName->pAbbrName[0]);
		//}
		iRetType = _RTYPE_CHAR;
		break;

	case SNMP_VT_MANIFACTURER:
		DxiGetData(VAR_ACU_PUBLIC_CONFIG,
			ACU_MANUFACTURER,			
			0,		
			&nBufLen,			
			pStrVal,			
			0);
		iRetType = _RTYPE_CHAR;
		break;

	case SNMP_VT_MODEL:
		strcpy(pStrVal, MANUFACTURER_MODEL);//Should be confirm
		iRetType = _RTYPE_CHAR;
		break;

	case SNMP_VT_FIRMWARE:
		
		memset(&sAcuProductInfo, 0, sizeof(sAcuProductInfo));
		nBufLen = sizeof(sAcuProductInfo);
		nError = DxiGetData(VAR_ACU_PUBLIC_CONFIG,
			    ACU_PRODUCT_INFO_GET, 
			    0, 
			    &nBufLen,
			    &(sAcuProductInfo),
			    0);
		if (nError != ERR_DXI_OK)
		{
			return _RTYPE_ERR;
		}
		sprintf(pStrVal, "%s", sAcuProductInfo.szSWRevision);
		iRetType = _RTYPE_CHAR;
		break;

	case SNMP_VT_SITENAME:
		nError = DxiGetData(VAR_ACU_PUBLIC_CONFIG,
			SITE_NAME,			
			0,		
			&nBufLen,			
			&pSiteLangText,			
			0);
		if (nError != ERR_DXI_OK)
		{
			return _RTYPE_ERR;
		}
		strcpy(pStrVal, pSiteLangText->pFullName[0]);//English name seng to nms
		iRetType = _RTYPE_CHAR;
		break;

	case SNMP_VT_INT:
		nError = DxiGetData(VAR_A_SIGNAL_VALUE,
			iEquipID,			
			DXI_MERGE_SIG_ID(pItInfo->nSigType, pItInfo->nSigID),
			&nBufLen,			
			&pSigValue,			
			0);
		if (nError != ERR_DXI_OK)
		{
			return _RTYPE_ERR;
		}
		iRetType = _RTYPE_INT;
		//注意这里不检查sigValtype，所以snmp_private.cfg上配置的数据类型必须与信号的实际类型一致，否则取到的值不对
		long lTmp = 0;
		if(pSigValue->ucType == VAR_FLOAT)
		{
			lTmp = (long)(pSigValue->varValue.fValue);
		}
		else
		{
			lTmp = (long)(pSigValue->varValue.lValue);
		}
		*pLVar = HandleSpecialVal(lTmp,pItInfo);
		//printf("\n-----------------%d,hhhhh",*pLVar);
		break;

	case SNMP_VT_FLOAT:
		nError = DxiGetData(VAR_A_SIGNAL_VALUE,
			iEquipID,			
			DXI_MERGE_SIG_ID(pItInfo->nSigType, pItInfo->nSigID),
			&nBufLen,			
			&pSigValue,			
			0);
		if (nError != ERR_DXI_OK)
		{
			return _RTYPE_ERR;
		}
		iRetType = _RTYPE_INT;
		if(pSigValue->ucType == VAR_FLOAT)
		{
			*pLVar = (long)(pSigValue->varValue.fValue*1000);//float val = val * 1000
		}
		else 
		{
			*pLVar = (long)(pSigValue->varValue.lValue*1000);//float val = val * 1000
		}
		//printf("\n-----------------%d,tttt",*pLVar);
		break;
		//following are for alarm tables
	case SNMP_VT_ALARMLASTNO:
		*pLVar = pSnmpInfoStru->ulAlarmSequenceID;
		iRetType = _RTYPE_INT;
		break;

	case SNMP_VT_ALARMTYPE:
		*pLVar = DXI_MERGE_UNIQUE_SIG_ID(
			s_pActiveAlarmSigValue[iIndex].pEquipInfo->iEquipID, 
			SIG_TYPE_ALARM, 
			s_pActiveAlarmSigValue[iIndex].pStdSig->iSigID);
		iRetType = _RTYPE_INT;
		break;

	case SNMP_VT_ALARMTIME:
		GetTimeString(s_pActiveAlarmSigValue[iIndex].sv.tmStartTime, pStrVal);
		iRetType = _RTYPE_CHAR;
		break;

	case SNMP_VT_ALARMSTCHANGE:
		*pLVar = ALARM_STATUS_ACTIVATED/*0*/;
		iRetType = _RTYPE_INT;
		break;

	case SNMP_VT_ALARMLEVEL:
		*pLVar = GetAlarmSeverity(s_pActiveAlarmSigValue[iIndex].pStdSig->iAlarmLevel);
		iRetType = _RTYPE_INT;
		break;

	case SNMP_VT_ALARMDESCRB:
		GetAlarmDescription(&(s_pActiveAlarmSigValue[iIndex]), pStrVal);
		iRetType = _RTYPE_CHAR;
		break;
	//以下四个是产品信息
	case SNMP_VT_PRDCT_NUM:
	case SNMP_VT_HW_VER:
	case SNMP_VT_SW_VER:
	case SNMP_VT_SERIAL_NUM:
		if(GetProductInfo_OutStr(iEquipID,pItInfo->nValueType,pStrVal))
		{
			iRetType = _RTYPE_CHAR;
		}
		break;
	}
	return iRetType;
}
static SNMP_SIG_ITEM_INFO* GetASigInfoFromMagic(int iMagic)
{
	int i = 0;
	for(; i < pSnmpInfoStru->nNodNum; i++)
	{
		if(pPowerMIB_variables[gpNodInfos[i].iVarIndex].magic == iMagic)
		{
			return &pSnmpInfoStru->pSnmpSigInfos[gpNodInfos[i].iSigItemIndex];
		}
	}
	return NULL;
}
unsigned char *
var_seperatedItem(struct variable *vp, 
			 oid     *name, 
			 size_t  *length, 
			 int     exact, 
			 size_t  *var_len, 
			 WriteMethod **write_method)
{
	/* variables we may use later */
	static long long_ret;
	static unsigned char string[SPRINT_MAX_LEN];	
	static SNMP_ACT_ITEM _ActItem;
//printf("\n==============Jimmy, I Got a cmd111111111111: %d.%d.%d.%d.%d.%d",name[8],name[9],name[10],name[11],name[12],name[13]);
	if (header_generic(vp,name,length,exact,var_len,write_method)
		== MATCH_FAILED )
	{
		//printf("\nyyyyyyyyyyyyyyyyy111111111");
		return NULL;
	}

	SNMP_SIG_ITEM_INFO *pItInfo = GetASigInfoFromMagic(vp->magic);
	if(pItInfo == NULL)
	{
		//printf("\nyyyyyyyyyyyyyyyyy2222222222");
		return NULL;
	}

	int iEquipID = DXI_GetEquipIDFromStdEquipID(pItInfo->nStdEquipID);

	if(pItInfo->nAccessAttr == RWRITE)
	{
		_ActItem.nEquipID = iEquipID;
		_ActItem.pSNMPSigInfo = pItInfo;
		pSnmpInfoStru->pTobeSetActItem = &_ActItem;
		*write_method = var_write_anItem;
	}
	
	int iRetType = GetAnItemValue(0,pItInfo,iEquipID,string,&long_ret);
	if(iRetType == _RTYPE_INT)
	{
		return (unsigned char *)&long_ret;
	}
	else if(iRetType == _RTYPE_CHAR)
	{
		if(pItInfo->nValueType == SNMP_VT_ALARMTIME)
		{
			*var_len = 11;// For Alarm Time
		}
		else
		{
			*var_len = strlen(string);
		}
		return (unsigned char *)string;
	}
	//printf("\nyyyyyyyyyyyyyyyyy3333333333,iEquipID = %d, SigType = %d, SigID = %d, iValType = %d, iRetType = %d",iEquipID,pItInfo->nSigType,pItInfo->nSigID,pItInfo->nValueType,iRetType);
	return NULL;
}
static BOOL Compare2Oid(_OID* pOid1,_OID* pOid2)
{
	if(pOid2->iLenth != pOid1->iLenth)
	{
		return FALSE;
	}
	int i = 0;
	int iLenM = (pOid1->iLenth > pOid2->iLenth)? pOid1->iLenth : pOid2->iLenth;
	for(; i < iLenM; i++)
	{
		if(pOid1->_oids[i] != pOid2->_oids[i])
		{
			return FALSE;
		}
	}
	return TRUE;
}
static int GetSNMPSigIdx_FromColumn(SNMP_SIG_ITEM_INFO* pColumnSnmpSigInfos, int iEquipTypeID, int iStart)
{
	//printf("\nQQQQQQQQ   type = %d, iStart = %   dQQQQQQQQQQ\n", iEquipTypeID, iStart);
	if(iStart < 0)
	{
		return -1;
	}
	int i = 0;
	int j = 0;
	for(i = iStart; i < pSnmpInfoStru->nSnmpSigNum; i++)
	{
		if(Compare2Oid(&pColumnSnmpSigInfos->oid_this,&pSnmpInfoStru->pSnmpSigInfos[i].oid_this))
		{
			if((!pSnmpInfoStru->pSnmpSigInfos[i].bMultiple) && pSnmpInfoStru->pSnmpSigInfos[i].nStdEquipID == iEquipTypeID)
			{
				//printf("\n111111111111111TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTfind = %d\n",i);
				return i;
			}
			else if(pSnmpInfoStru->pSnmpSigInfos[i].bMultiple)
			{
				for(j = 0; j < pSnmpInfoStru->pSnmpSigInfos[i].nEquipIndexNum; j++)
				{
					int iIdx = pSnmpInfoStru->pSnmpSigInfos[i].piIndexList[j] - 1;
					
					if(iIdx >= 0 && iIdx < pColumnSnmpSigInfos->pTableInfo->nEquipTypeNums)
					{
						int iEquipTypeID_R = pColumnSnmpSigInfos->pTableInfo->pEquipTypeIDList[iIdx];
//printf("\n-------JJJJJJ = %d , EquipTTT = %d, and ETTTyte= %d ",iIdx,iEquipTypeID_R,iEquipTypeID);
						if(iEquipTypeID_R == iEquipTypeID)
						{
							//printf("\n2222222222222222TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTfind = %d\n",i);
							return i;
						}
					}
				}
			}
			
		}
	}
	return -1;
}
#define MAX_EQUIP_LIST_NUMM 300
static BOOL CreatActEquipList(IN int iEquipTypeID,OUT int* piActNum, OUT EQUIP_INFO** ppActEquipInfo)
{
	int		iBufLen;
	int		nEquipTotalNum;
	int		i = 0;

	EQUIP_INFO	*pEquipList;
	int nError = DxiGetData(VAR_ACU_EQUIPS_LIST, 
		0,
		0,
		&iBufLen,
		&pEquipList,
		0);
	if(ERR_DXI_OK != nError)
	{
		return FALSE;
	}
	nEquipTotalNum = iBufLen / sizeof(EQUIP_INFO);
	
	int j = 0;
	for(i = 0; i < nEquipTotalNum && j < MAX_EQUIP_LIST_NUMM; i++,pEquipList++)
	{
		if(pEquipList->pStdEquip->iTypeID == iEquipTypeID)
		{
			if(pEquipList->bWorkStatus)
			{
				*(ppActEquipInfo + j) = pEquipList;
				j++;
			}
		}
	}
	*piActNum = j;
	if(j < 1)
	{
		return FALSE; //没有List
	}
	return TRUE;
}
static int CreateActRow(SNMP_SIG_ITEM_INFO** pColumnSnmpSigInfos,int iEquipTypeID, OUT SNMP_ACT_TABLE* pActTable )
{
	int iRow = pActTable->nRowsNum;
	int iColumn = pActTable->nColumnNum;

	EQUIP_INFO* pEquipList[MAX_EQUIP_LIST_NUMM];
	int iEquipCount = 0;//get a type equip count
	if(!CreatActEquipList(iEquipTypeID,&iEquipCount,&pEquipList))
	{
		return 0;
	}
	int i = 0, j = 0;
	int k,iStart;
	SNMP_ACT_ITEM* pActIntem = &pActTable->pActItems[iRow * iColumn];
	SNMP_TABLE_ITEM_INFO* ptableInfo = pActTable->pTableInfo;

	if(ptableInfo->iIndexMethod == 1) // x
	{
		SNMP_SIG_ITEM_INFO* pSNMPSigTmp = NULL;
		//printf("\n00000000000XXXXXXX\n");
		for(j = 0; j < iEquipCount; j++)
		{	
			//计算RowIndex
			pActTable->iActRowList[j + iRow] = pEquipList[j]->iEquipID;
			//printf("\nIIIIIIIIIIID = %d , TTTTTTTId = %d\n", iEquipTypeID, pEquipList[j]->iEquipID);
			for(i = 0; i < iColumn; i++)
			{
				iStart = GetSNMPSigIdx_FromColumn(pColumnSnmpSigInfos[i],iEquipTypeID,0);
				if(iStart >= 0)
				{
					pSNMPSigTmp = &pSnmpInfoStru->pSnmpSigInfos[iStart];
					pSNMPSigTmp->nStdEquipID = iEquipTypeID;
					pActIntem[j * iColumn + i].bIsValid = TRUE;
					pActIntem[j * iColumn + i].iRowIdx = pActTable->iActRowList[j + iRow];					
					pActIntem[j * iColumn + i].iColIdx = pSNMPSigTmp->oid_this._oids[pSNMPSigTmp->oid_this.iLenth - 1];
					pActIntem[j * iColumn + i].nEquipID = pEquipList[j]->iEquipID;
					pActIntem[j * iColumn + i].pSNMPSigInfo = pSNMPSigTmp;
					
				}
			}
			
		}
		return iEquipCount;
	}
	else if(ptableInfo->iIndexMethod == 2) // y
	{
		//printf("\n00000000000YYYYYYYYYYY\n");
		//这里为了降低复杂度，我们规定设备是单个的，所以EquipList实际上只有一个，不会产生多重映射
		//先找出所有的multipleItem的集合
#define MAX_MULT_SIG_NUM	500
		int nError,nBufLen;
		SIG_BASIC_VALUE	*pSigNeedDisp;
		SNMP_SIG_ITEM_INFO* pSNMPSigItemList[MAX_MULT_SIG_NUM];
		SNMP_SIG_ITEM_INFO* pOtherSNMPSigItemList[MAX_MULT_SIG_NUM];
		//判断是否是EIB设备，后面需要对它进行特殊处理
		BOOL bIsEIB = (iEquipTypeID == 901) ? TRUE : FALSE;
		for(i = 0; i < iColumn; i++)
		{
			if(Compare2Oid(&pColumnSnmpSigInfos[i]->oid_this,&ptableInfo->oid_index))
			{
				break;
			}

		}
		iStart = 0;
		for(k = 0; k < MAX_MULT_SIG_NUM; k++)
		{
			j = GetSNMPSigIdx_FromColumn(pColumnSnmpSigInfos[i],iEquipTypeID,iStart);
			if(j < 0)
			{
				break;
			}
			pSNMPSigItemList[k] = &pSnmpInfoStru->pSnmpSigInfos[j];
			iStart = j + 1;
		}
		//总共k row
		int iTotalRow = k;
		SNMP_SIG_ITEM_INFO* pSNMPEIBCurr[3];
		int iKKEIBStart = -1;
		int iEIBCurrTotal = 0;
		BOOL bEIBCurrExist[4][3] = {FALSE};
		int iCurrEIBIdx = 0;
		//printf("\n The Total row = %d \n", iTotalRow);
		//判断信号是否有效
		//SAMPLE_SIG_VALUE	*pSigNeedDisp;
		//int nError,nBufLen;
		for(i = 0,k = 0; i < iTotalRow; i++)
		{	
			//pActTable->iActRowList[i + iRow] = 0;
			//nError = DxiGetData(VAR_A_SIGNAL_VALUE,
			//	pEquipList[0]->iEquipID,			
			//	DXI_MERGE_SIG_ID(pSNMPSigItemList[i]->nSigType, pSNMPSigItemList[i]->nSigID),
			//	&nBufLen,			
			//	&pSigNeedDisp,			
			//	0);
			//if (nError != ERR_DXI_OK)
			//{
			//	continue;
			//}
			//if(!SIG_VALUE_NEED_DISPLAY(pSigNeedDisp))
			//{
			//	continue;
			//}
			//温度，需要特殊处理，Jimmy 2014.06.11
			if(ptableInfo->nTableID == 2)//index用作决定是否显示
			{
				DxiGetData(VAR_A_SIGNAL_VALUE,
					pEquipList[0]->iEquipID,			
					DXI_MERGE_SIG_ID(pSNMPSigItemList[i]->nSigType, pSNMPSigItemList[i]->nSigID),
					&nBufLen,			
					&pSigNeedDisp,			
					0);
				if((pSigNeedDisp == NULL) || ((!SIG_VALUE_NEED_DISPLAY(pSigNeedDisp)) || (pSigNeedDisp->varValue.ulValue < 1)))
				{
					continue;
				}
				pActTable->iActRowList[k + iRow] = DXI_MERGE_UNIQUE_SIG_ID(pEquipList[0]->iEquipID,pSNMPSigItemList[i]->nSigType,pSNMPSigItemList[i]->nSigID);
				k++;
			}
			else if(ptableInfo->nTableID == 4 || ptableInfo->nTableID == 8)//DC, 特殊处理
			{
				if(bIsEIB)
				{
					if(iKKEIBStart < 0)//开始个数
					{
						iKKEIBStart = k;
					}
					if(iCurrEIBIdx >= 3)
					{
						continue;
					}
					pSNMPEIBCurr[iCurrEIBIdx] = pSNMPSigItemList[i];
					//EIB1
					DxiGetData(VAR_A_SIGNAL_VALUE,
						pEquipList[0]->iEquipID,			
						DXI_MERGE_SIG_ID(pSNMPSigItemList[i]->nSigType, pSNMPSigItemList[i]->nSigID),
						&nBufLen,			
						&pSigNeedDisp,			
						0);
					if((pSigNeedDisp == NULL) || ((!SIG_VALUE_NEED_DISPLAY(pSigNeedDisp)) || (!SIG_VALUE_IS_VALID(pSigNeedDisp))))
					{
						//continue;
						bEIBCurrExist[0][iCurrEIBIdx] = FALSE;
					}
					else
					{
						bEIBCurrExist[0][iCurrEIBIdx] = TRUE;
						pActTable->iActRowList[k + iRow] = DXI_MERGE_UNIQUE_SIG_ID(pEquipList[0]->iEquipID,pSNMPSigItemList[i]->nSigType,pSNMPSigItemList[i]->nSigID);
						k++;
						iEIBCurrTotal++;
					}

					//EIB2
					if(iEquipCount < 2)
					{
						iCurrEIBIdx++;
						continue;
					}
					DxiGetData(VAR_A_SIGNAL_VALUE,
						pEquipList[1]->iEquipID,			
						DXI_MERGE_SIG_ID(pSNMPSigItemList[i]->nSigType, pSNMPSigItemList[i]->nSigID),
						&nBufLen,			
						&pSigNeedDisp,			
						0);
					if((pSigNeedDisp == NULL) || ((!SIG_VALUE_NEED_DISPLAY(pSigNeedDisp)) || (!SIG_VALUE_IS_VALID(pSigNeedDisp))))
					{
						//continue;
						bEIBCurrExist[1][iCurrEIBIdx] = FALSE;
					}
					else
					{
						bEIBCurrExist[1][iCurrEIBIdx] = TRUE;
						pActTable->iActRowList[k + iRow] = DXI_MERGE_UNIQUE_SIG_ID(pEquipList[1]->iEquipID,pSNMPSigItemList[i]->nSigType,pSNMPSigItemList[i]->nSigID);
						k++;
						iEIBCurrTotal++;
					}

					//EIB3
					if(iEquipCount < 3)
					{
						iCurrEIBIdx++;
						continue;
					}
					DxiGetData(VAR_A_SIGNAL_VALUE,
						pEquipList[2]->iEquipID,			
						DXI_MERGE_SIG_ID(pSNMPSigItemList[i]->nSigType, pSNMPSigItemList[i]->nSigID),
						&nBufLen,			
						&pSigNeedDisp,			
						0);
					if((pSigNeedDisp == NULL) || ((!SIG_VALUE_NEED_DISPLAY(pSigNeedDisp)) || (!SIG_VALUE_IS_VALID(pSigNeedDisp))))
					{
						//continue;
						bEIBCurrExist[2][iCurrEIBIdx] = FALSE;
					}
					else
					{
						bEIBCurrExist[2][iCurrEIBIdx] = TRUE;
						pActTable->iActRowList[k + iRow] = DXI_MERGE_UNIQUE_SIG_ID(pEquipList[2]->iEquipID,pSNMPSigItemList[i]->nSigType,pSNMPSigItemList[i]->nSigID);
						k++;
						iEIBCurrTotal++;
					}

					//EIB4
					if(iEquipCount < 4)
					{
						iCurrEIBIdx++;
						continue;
					}
					DxiGetData(VAR_A_SIGNAL_VALUE,
						pEquipList[3]->iEquipID,			
						DXI_MERGE_SIG_ID(pSNMPSigItemList[i]->nSigType, pSNMPSigItemList[i]->nSigID),
						&nBufLen,			
						&pSigNeedDisp,			
						0);
					if((pSigNeedDisp == NULL) || ((!SIG_VALUE_NEED_DISPLAY(pSigNeedDisp)) || (!SIG_VALUE_IS_VALID(pSigNeedDisp))))
					{
						//continue;
						bEIBCurrExist[3][iCurrEIBIdx] = FALSE;
					}
					else
					{
						bEIBCurrExist[3][iCurrEIBIdx] = TRUE;
						pActTable->iActRowList[k + iRow] = DXI_MERGE_UNIQUE_SIG_ID(pEquipList[3]->iEquipID,pSNMPSigItemList[i]->nSigType,pSNMPSigItemList[i]->nSigID);
						k++;
						iEIBCurrTotal++;
					}

					iCurrEIBIdx++;
				}
				else
				{
					DxiGetData(VAR_A_SIGNAL_VALUE,
						pEquipList[0]->iEquipID,			
						DXI_MERGE_SIG_ID(pSNMPSigItemList[i]->nSigType, pSNMPSigItemList[i]->nSigID),
						&nBufLen,			
						&pSigNeedDisp,			
						0);
					if((pSigNeedDisp == NULL) || ((!SIG_VALUE_NEED_DISPLAY(pSigNeedDisp)) || (!SIG_VALUE_IS_VALID(pSigNeedDisp))))
					{
						continue;
					}
					pActTable->iActRowList[k + iRow] = DXI_MERGE_UNIQUE_SIG_ID(pEquipList[0]->iEquipID,pSNMPSigItemList[i]->nSigType,pSNMPSigItemList[i]->nSigID);
					k++;
				}
			}
			//pActTable->iActRowList[k + iRow] = DXI_MERGE_UNIQUE_SIG_ID(pEquipList[0]->iEquipID,pSNMPSigItemList[i]->nSigType,pSNMPSigItemList[i]->nSigID);
			//k++;
			//printf("\n ))))the EID = %d, SigType = %d, SigId = %d, RowIdx = %d\n",pEquipList[0]->iEquipID,
			//	pSNMPSigItemList[i]->nSigType,
			//	pSNMPSigItemList[i]->nSigID,
			//	pActTable->iActRowList[i + iRow]);
		}
		iTotalRow = k;

		iCurrEIBIdx = 0;
		if (ptableInfo->nTableID == 4 || ptableInfo->nTableID == 8)
		{
			if(bIsEIB && (iEIBCurrTotal > 0))
			{
				//printf("\n--------------Begin Print EIB------------");
				for(i = 0; i < 4; i++)
				{
					for(j = 0; j < 3; j++)
					{
						if(bEIBCurrExist[i][j])
						{
							//printf("\n[%d] EIB-%d,Load-%d",iCurrEIBIdx,i,j);
							pActTable->iActRowList[iCurrEIBIdx + iKKEIBStart + iRow] = 
								DXI_MERGE_UNIQUE_SIG_ID(pEquipList[i]->iEquipID,pSNMPEIBCurr[j]->nSigType,pSNMPEIBCurr[j]->nSigID);
							iCurrEIBIdx++;
						}
					}
				}
				//printf("\n---------------End Print----------------\n");
			}
		}

		//其它所有列的处理
		int s;
		int iii;
		//对EIB设备需特殊处理映射关系
		int iEIB[4][3] = {0};
		int iEIBIdx = 0;
		for(i = 0; i < iColumn; i++)
		{
			iStart = 0;
			iEIBIdx = 0;
			for(k = 0,j = 0; k < MAX_MULT_SIG_NUM; k++)
			{
				s = GetSNMPSigIdx_FromColumn(pColumnSnmpSigInfos[i],iEquipTypeID,iStart);
				if(s < 0)
				{
					break;
				}
				iStart = s + 1;
				//同上面，要求snmp_private.cfg里面的列要一一对应，否则可能出现偏差。Jimmy 2014.06.11
				if(ptableInfo->nTableID == 2)//index用作决定是否显示
				{
					DxiGetData(VAR_A_SIGNAL_VALUE,
						pEquipList[0]->iEquipID,			
						DXI_MERGE_SIG_ID(pSNMPSigItemList[k]->nSigType, pSNMPSigItemList[k]->nSigID),
						&nBufLen,			
						&pSigNeedDisp,			
						0);
					if((pSigNeedDisp == NULL) || ((!SIG_VALUE_NEED_DISPLAY(pSigNeedDisp)) || (pSigNeedDisp->varValue.ulValue < 1)))
					{
						continue;
					}
				}
				else if(ptableInfo->nTableID == 4 || ptableInfo->nTableID == 8)//DC, 特殊处理
				{
					if(bIsEIB)
					{
						if(iEIBIdx >= 3)
						{
							continue;
						}
						//4 个EIB
						for(iii = 0; (iii < iEquipCount) && (iii < 4); iii++)
						{
							DxiGetData(VAR_A_SIGNAL_VALUE,
								pEquipList[iii]->iEquipID,			
								DXI_MERGE_SIG_ID(pSNMPSigItemList[k]->nSigType, pSNMPSigItemList[k]->nSigID),
								&nBufLen,			
								&pSigNeedDisp,			
								0);
							if((pSigNeedDisp == NULL) || ((!SIG_VALUE_NEED_DISPLAY(pSigNeedDisp)) || (!SIG_VALUE_IS_VALID(pSigNeedDisp))))
							{
								//continue;
								iEIB[iii][iEIBIdx] = 0;
							}
							else
							{
								iEIB[iii][iEIBIdx] = 1;
							}
						}
						iEIBIdx++;
					}
					else
					{
						DxiGetData(VAR_A_SIGNAL_VALUE,
							pEquipList[0]->iEquipID,			
							DXI_MERGE_SIG_ID(pSNMPSigItemList[k]->nSigType, pSNMPSigItemList[k]->nSigID),
							&nBufLen,			
							&pSigNeedDisp,			
							0);
						if((pSigNeedDisp == NULL) || ((!SIG_VALUE_NEED_DISPLAY(pSigNeedDisp)) || (!SIG_VALUE_IS_VALID(pSigNeedDisp))))
						{
							continue;
						}
					}
				}
				pOtherSNMPSigItemList[j] = &pSnmpInfoStru->pSnmpSigInfos[s];
				j++;
			}
			int iEIBTT = 0;
			if(bIsEIB)
			{
				for(iii = 0; iii < 4; iii++)
				{
					for(s = 0; (s < j) && (s < 3); s++)
					{
						if(iEIB[iii][s] == 1)
						{
							//printf("\n----EIB::::::s = %d, iEquipID = %d",s,pEquipList[iii]->iEquipID);
							pActIntem[iEIBTT * iColumn + i].bIsValid = TRUE;//(pActTable->iActRowList[s + iRow] > 0) ? TRUE : FALSE;
							pActIntem[iEIBTT * iColumn + i].iRowIdx = pActTable->iActRowList[iEIBTT + iRow];					
							pActIntem[iEIBTT * iColumn + i].iColIdx = pOtherSNMPSigItemList[s]->oid_this._oids[pOtherSNMPSigItemList[s]->oid_this.iLenth - 1];
							pActIntem[iEIBTT * iColumn + i].nEquipID = pEquipList[iii]->iEquipID;
							pActIntem[iEIBTT * iColumn + i].pSNMPSigInfo = pOtherSNMPSigItemList[s];
							iEIBTT++;
						}
					}
				}
			}
			else
			{
				for(s = 0; s < j; s++)
				{
					//printf("\n----OOOO::s = %d, iEquipID = %d",s,pEquipList[0]->iEquipID);
					pActIntem[s * iColumn + i].bIsValid = TRUE;//(pActTable->iActRowList[s + iRow] > 0) ? TRUE : FALSE;
					pActIntem[s * iColumn + i].iRowIdx = pActTable->iActRowList[s + iRow];					
					pActIntem[s * iColumn + i].iColIdx = pOtherSNMPSigItemList[s]->oid_this._oids[pOtherSNMPSigItemList[s]->oid_this.iLenth - 1];
					pActIntem[s * iColumn + i].nEquipID = pEquipList[0]->iEquipID;
					pActIntem[s * iColumn + i].pSNMPSigInfo = pOtherSNMPSigItemList[s];
				}
			}

		}
		return iTotalRow;

	}
	else	//z,暂时不支持,仅在activealarm里支持
	{
		return 0;
	}
}

static void CreatActTable(OUT SNMP_ACT_TABLE* pActTable)
{
	SNMP_SIG_ITEM_INFO* pColumnSnmpSigInfos[MAX_SNMP_TABLE_COLUMN];
	int i = 0;
	int iColumnLen = 0;
	int iMax = MAX_SNMP_TABLE_ROWS*MAX_SNMP_TABLE_COLUMN;
	//initialize 
	for(i =0; i < iMax; i++)
	{
		pActTable->pActItems[i].bIsValid = FALSE;//all false
		pActTable->pActItems[i].nEquipID = -999;
	}
	for(i = 0;i < pSnmpInfoStru->nNodNum; i++)
	{
		if(pSnmpInfoStru->pSnmpSigInfos[gpNodInfos[i].iSigItemIndex].pTableInfo != NULL
			&& (pSnmpInfoStru->pSnmpSigInfos[gpNodInfos[i].iSigItemIndex].nValueType != SNMP_VT_INDEX))
		{
			if(pSnmpInfoStru->pSnmpSigInfos[gpNodInfos[i].iSigItemIndex].pTableInfo->nTableID == pActTable->pTableInfo->nTableID)
			{
				pColumnSnmpSigInfos[iColumnLen] = &pSnmpInfoStru->pSnmpSigInfos[gpNodInfos[i].iSigItemIndex];
				iColumnLen++;
				if(iColumnLen >= MAX_SNMP_TABLE_COLUMN)
				{
					break;
				}
			}
		}
		
	}
	
	pActTable->nColumnNum = iColumnLen;
	pActTable->nRowsNum = 0;
	pActTable->nGetTimes = 0;
	if(pActTable->pTableInfo->nEquipTypeNums > 0)// using equip type for creating
	{
		for(i = 0; i < pActTable->pTableInfo->nEquipTypeNums; i++)
		{
			pActTable->nRowsNum  += CreateActRow(pColumnSnmpSigInfos,pActTable->pTableInfo->pEquipTypeIDList[i],pActTable);
			//printf("\nJimmy, Type = %d; Row = %d;",pActTable->pTableInfo->pEquipTypeIDList[i],pActTable->nRowsNum);
		}
	}
#ifdef _SNMP_TEST_M
	printf("\n_____________Created table OK, , nType = %d, total Row: %d!!_________________",pActTable->pTableInfo->nEquipTypeNums,pActTable->nRowsNum);
	for(i = 0; i < pActTable->nRowsNum; i++)
	{
		printf("\n%d. Index = %d", i+ 1, pActTable->iActRowList[i]);
	}
	printf("\n_________________________");
#endif

}
static SNMP_ACT_ITEM* GetActItem_FromNod(SNMP_ACT_TABLE* pActTable,int iOidLast, int iRowId)
{
	SNMP_ACT_ITEM* pActIt = NULL;
	int i = 0;
	int iMax = pActTable->nRowsNum * pActTable->nColumnNum;
	for(; i < iMax; i++)
	{
		if(pActTable->pActItems[i].bIsValid && 
			pActTable->pActItems[i].iRowIdx == iRowId &&
			pActTable->pActItems[i].iColIdx == iOidLast)
		{
			pActIt = &pActTable->pActItems[i];
		}
	}
	return pActIt;
}
static SNMP_ACT_TABLE* pActTable = NULL;
static oid GetNextIndex_FromActTable(int iPreID)
{
	int i = 0;
	for (; i < pActTable->nRowsNum - 1; i++)
	{
		if(iPreID == pActTable->iActRowList[i])
		{
			return pActTable->iActRowList[i + 1];
		}
	}
	return 0;
}
//JimmyWu：代码从snmp源码包修改而来(code is from SNMP agent source code package)
int header_my_table(struct variable *vp, oid *name, size_t *length,
						int exact, size_t *var_len,
						WriteMethod **write_method)
{

	BOOL bIsAlamTable = TRUE; //特殊处理alarm表
	if(pActTable != NULL)
	{
		if(pActTable->pTableInfo != NULL)
		{
			bIsAlamTable = FALSE;
		}
	}
	int	i,rtest;	/* Set to:	-1	If name < vp->name,
				*		1	If name > vp->name,
				*		0	Otherwise.
				*/
	oid newname[MAX_OID_LEN];

	for(i=0,rtest=0; i < (int) vp->namelen && i < (int)(*length) && !rtest; i++) {
		if (name[i] != vp->name[i]) {
			if (name[i] < vp->name[i]) 
				rtest = -1;
			else
				rtest = 1;
		}
	}
	if (rtest > 0 ||
		(exact == 1 && (rtest || (int)*length != (int)(vp->namelen+1)))) 
	{
			if (var_len)
			{
				*var_len = 0;
			}
			return MATCH_FAILED;
	}

	memset(newname, 0, sizeof(newname));

	if (((int) *length) <= (int) vp->namelen || rtest == -1) 
	{
		memmove(newname, vp->name, (int)vp->namelen * sizeof (oid));
		if(bIsAlamTable)
		{
			newname[vp->namelen] = 1;
		}
		else
		{
			newname[vp->namelen] = (pActTable->nRowsNum > 0) ? pActTable->iActRowList[0] : 0;
		}
		
		*length = vp->namelen+1;
	} 
	else if (((int)*length) > (int)vp->namelen+1) 
	{  /* exact case checked earlier */
		*length = vp->namelen+1;
		memmove(newname, name, (*length) * sizeof(oid));
		if(bIsAlamTable)
		{
			newname[*length-1] = name[*length-1] + 1;
		}
		else
		{
			newname[*length-1] = GetNextIndex_FromActTable(name[*length-1]);
		}
		
	}
	else 
	{
		*length = vp->namelen+1;
		memmove(newname, name, (*length) * sizeof(oid));
		if (!exact) //GETNEXT
		{
			if(bIsAlamTable)
			{
				newname[*length-1] = name[*length-1] + 1;
			}
			else
			{
				newname[*length-1] = GetNextIndex_FromActTable(name[*length-1]);
			}
		}
		else//GET
		{
			newname[*length-1] = name[*length-1];
		}
	}  
	if (/*(max >= 0 && (newname[*length-1] > max)) ||*/
		(0 == newname[*length-1] )) 
	{
			if(var_len)
			{
				*var_len = 0;
			}
			return MATCH_FAILED;
	}

	memmove(name, newname, (*length) * sizeof(oid)); 
	if (write_method)
		*write_method = 0;
	if (var_len)
		*var_len = sizeof(long);   /* default */
	return(MATCH_SUCCEEDED);
}


unsigned char *
var_tableItem(struct variable *vp,
			  oid     *name,
			  size_t  *length,
			  int     exact,
			  size_t  *var_len,
			  WriteMethod **write_method)
{

//printf("\n==============Jimmy, I Got a cmd2: %d.%d.%d.%d.%d.%d",name[9],name[10],name[11],name[12],name[13],name[14]);
//printf("\n==============Jimmy, I Got a VPPPPcmd2: %d.%d.%d.%d.%d.%d",vp->name[9],vp->name[10],vp->name[11],vp->name[12],vp->name[13],vp->name[14]);
	/* variables we may use later */
	static long long_ret;
	static unsigned char string[SPRINT_MAX_LEN];
	static SNMP_ACT_ITEM _ActItem;
	int iEquipID = -1;

	static int iLastTableID = -1; //上一次查询的table
	static int iActiveAlarmGetTimes = 0;
#define ALARM_TABLE_ID_S -2;
	SNMP_SIG_ITEM_INFO *pItInfo = GetASigInfoFromMagic(vp->magic);
	if(pItInfo == NULL)
	{
		return NULL;
	}
	SNMP_TABLE_ITEM_INFO* pTableInfo = pItInfo->pTableInfo;
	if(pTableInfo == NULL)
	{
		return NULL;
	}
	//先重建表
	
	if(pTableInfo->nEquipTypeNums == -1) //alarm
	{
		if(s_pActiveAlarmSigValue == NULL)
		{
			//printf("\n--------------------------------------Build Alarm table---------------------------\n");
			iLastTableID = ALARM_TABLE_ID_S;
			DELETE_ITEM(pActTable);
			DXI_GetActiveAlarmItems(&s_nActiveAlarmNum, &s_pActiveAlarmSigValue);
			iActiveAlarmGetTimes = 0;
		}
	}
	else
	{
		BOOL bNeedCreatActTabl = FALSE;
		if(pActTable == NULL)
		{
			bNeedCreatActTabl = TRUE;
		}
		else if(pActTable != NULL && (pTableInfo->nTableID != iLastTableID))
		{
			//printf("\n-------Old TableId = %d, new TableID = %d-------------\n",iLastTableID,pTableInfo->nTableID);
			bNeedCreatActTabl = TRUE;
		}
		if (bNeedCreatActTabl) //create/update table
		{
			//printf("\n--------------------------------------Build Other table---------------------------\n");
			DELETE_ITEM(pActTable);
			DELETE_ITEM(s_pActiveAlarmSigValue);
			pActTable = NEW(SNMP_ACT_TABLE,1);
			if(pActTable == NULL)
			{
				return NULL;
			}
			pActTable->pTableInfo = pTableInfo;
			pActTable->nGetTimes = 0;
			CreatActTable(pActTable);
			iLastTableID = pTableInfo->nTableID;
		}
	}

	//Jimmy注: 经查阅snmp源代码，exact参数的意义在于区分Get还是GetNext，如果是后者则通过下面的header函数后
	//执行后name会自动跳到下一个oid
	if (header_my_table(vp,name,length,exact,var_len,write_method)
		== MATCH_FAILED )
	{
		//printf("\n++++DDDnot match");
		return NULL;
	}

	//printf("\n==============Jimmy, I Got a JJJJJJJJJJJJJJJJJJJJJJcmd2: %d.%d.%d.%d.%d.%d",name[9],name[10],name[11],name[12],name[13],name[14]);

	int nGetSequence = name[*length - 1];
	int nSubOid = name[*length - 2];
	
	if(pTableInfo->nEquipTypeNums == -1) //alarm
	{
		if (nGetSequence > s_nActiveAlarmNum || s_pActiveAlarmSigValue == NULL)// 6 是表的列数
		{
			iActiveAlarmGetTimes++;
			if(iActiveAlarmGetTimes >= 6)//6是告警列表列数
			{
				DELETE_ITEM(s_pActiveAlarmSigValue);
			}
			return NULL;
		}
		else if(pItInfo->nValueType == SNMP_VT_INDEX)
		{
			//printf("\n))))))))))))))))Get index nS222ex = %d \n",0);
			long_ret = 0 ;
			return (unsigned char *)&long_ret;
		}
		else
		{
			iEquipID = 0;
			iEquipID = s_pActiveAlarmSigValue[nGetSequence - 1].pEquipInfo->iEquipID;
		}
	}
	else if(pTableInfo->nEquipTypeNums == -2) //equipSignaltable,特殊处理
	{
		//从name中解析出eID/SigType和SigID
		DXI_SPLIT_UNIQUE_SIG_ID(nGetSequence,
						iEquipID,
						pItInfo->nSigType,
						pItInfo->nSigID);
		if(pItInfo->nValueType == SNMP_VT_INDEX)//返回 table Index，经过header_my_table函数特殊处理
		{
			//printf("\n))))))))))))))))Get index nS0000ex = %d \n",nGetSequence);
			long_ret = nGetSequence ;
			return (unsigned char *)&long_ret;
		}

	}
	else
	{

		if(pItInfo->nValueType == SNMP_VT_INDEX)//返回 table Index，经过header_my_table函数特殊处理
		{
			//printf("\n))))))))))))))))Get index nSex = %d \n",nGetSequence);
			long_ret = nGetSequence ;
			return (unsigned char *)&long_ret;
		}

		SNMP_ACT_ITEM* pActItem = GetActItem_FromNod(pActTable,nSubOid,nGetSequence);
		if(pActItem != NULL)
		{
			pActTable->nGetTimes++;
			iEquipID = pActItem->nEquipID;
			pItInfo = pActItem->pSNMPSigInfo;
			_ActItem.nEquipID = iEquipID;
			_ActItem.pSNMPSigInfo = pItInfo;
		}
		else
		{
			return NULL;
		}
		if(pActTable->nGetTimes >= 3*pActTable->nRowsNum * pActTable->nColumnNum)//3次walk之后则重新建表，因为建表比较慢
		{
			DELETE_ITEM(pActTable);//need rebuild table
		}

	}

	if(pItInfo->nAccessAttr == RWRITE)
	{
		pSnmpInfoStru->pTobeSetActItem = &_ActItem;
		*write_method = var_write_anItem;
	}
	
	int iRetType = GetAnItemValue(nGetSequence - 1,pItInfo,iEquipID,string,&long_ret);

	if(iRetType == _RTYPE_INT)
	{
		return (unsigned char *)&long_ret;
	}
	else if(iRetType == _RTYPE_CHAR)
	{
		if(pItInfo->nValueType == SNMP_VT_ALARMTIME)
		{
			*var_len = 11;// For Alarm Time
		}
		else
		{
			*var_len = strlen(string);
		}
		return (unsigned char *)string;
	}

	return NULL;
}
/*
* var_alarmTrapTable():
*   Handle this table separately from the scalar value case.
*   The workings of this are basically the same as for var_powerMIB above.
*/
static int GetSNMPValType_FromSig(SNMP_SIG_ITEM_INFO* pSigInfo)
{
	int iRet = ASN_INTEGER;
	switch(pSigInfo->nValueType)
	{
	case SNMP_VT_INT:
	case SNMP_VT_FLOAT:
	case SNMP_VT_ALARMLASTNO:
	case SNMP_VT_ALARMLEVEL:
	case SNMP_VT_ALARMTYPE:
	case SNMP_VT_INDEX:
		iRet = ASN_INTEGER;
		break;
	default:
		iRet = ASN_OCTET_STR;
		break;
	}
	return iRet;
}
int var_write_anItem(int      action,
				u_char   *var_val,
				u_char   var_val_type,
				size_t   var_val_len,
				u_char   *statP,
				oid      *name,
				size_t   name_len)
{
	//printf("\n==============Jimmy, I Got a cmd5: %d.%d.%d.%d",name[0],name[1],name[2],name[3]);
	static unsigned char string[SPRINT_MAX_LEN];
	long lvarTemp;

	int nError = ERR_DXI_OK;

	int	nEquipId, nSignalType, nSignalID;

	VAR_VALUE_EX	varValueEx;

	nEquipId = pSnmpInfoStru->pTobeSetActItem->nEquipID;

	nSignalType = pSnmpInfoStru->pTobeSetActItem->pSNMPSigInfo->nSigType;
	nSignalID = pSnmpInfoStru->pTobeSetActItem->pSNMPSigInfo->nSigID;

	varValueEx.nSendDirectly = EQUIP_CTRL_SEND_DIRECTLY;

	//Frank Wu,1/N/N,20151126, for the SNMP write operation isn't logged in the Event Log
	//varValueEx.nSenderType = SERVICE_OF_LOGIC_CONTROL;
	varValueEx.nSenderType = SERVICE_OF_DATA_COMM;
	varValueEx.pszSenderName = "SNMP server";

	

	if(var_val == NULL || pSnmpInfoStru->pTobeSetActItem == NULL)
	{
		return SNMP_ERR_GENERR;
	}

	lvarTemp = *((long*)var_val);
	switch ( action ) 
	{
	case RESERVE1:
		if (var_val_type != GetSNMPValType_FromSig(pSnmpInfoStru->pTobeSetActItem->pSNMPSigInfo))
		{
			return SNMP_ERR_WRONGTYPE;
		}
		//printf("\nSet Command:var_type = %d, val_val = %s, val_len = %d, size = %d\n",var_val_type,var_val,var_val_len);
		if (((var_val_len > 32) && var_val_type == ASN_OCTET_STR) || 
			(var_val_len > sizeof(long) && var_val_type == ASN_INTEGER))
		{
			return SNMP_ERR_WRONGLENGTH;
		}
		break;


	case RESERVE2:
		break;


	case FREE:
		/* Release any resources that have been allocated */
		break;


	case ACTION:
		/* The variable has been stored in string for
		you to use, and you have just been asked to do something with
		it.  Note that anything done here must be reversable in the UNDO case */

		switch(pSnmpInfoStru->pTobeSetActItem->pSNMPSigInfo->nValueType)
		{
		case SNMP_VT_SITENAME:
			strncpyz(string,var_val, var_val_len + 1);
			if (DxiSetData(VAR_ACU_PUBLIC_CONFIG,
				SITE_NAME,			
				MODIFY_SITE_ENGLISH_FULL_NAME,		
				var_val_len,			
				string,			
				SET_TIME_OUT) != ERR_DXI_OK)
			{
				return SNMP_ERR_GENERR;
			}
			AppLogOut("SNMP", APP_LOG_INFO,
				"Changed Site Name to %s !",string);
			break;
		case SNMP_VT_INT:
			varValueEx.varValue.lValue = lvarTemp;
			nError = DxiSetData(VAR_A_SIGNAL_VALUE,
				nEquipId,			
				DXI_MERGE_SIG_ID(nSignalType, nSignalID),
				sizeof(VAR_VALUE_EX),
				&(varValueEx),
				0);
			AppLogOut("SNMP", APP_LOG_INFO,
				"Control EquipID=%d,SigType=%d,SigValue=%d,Value=%d,cmd executed %s!",
				nEquipId,nSignalType,nSignalID,
				lvarTemp,
				(nError == ERR_DXI_OK) ? "Successfully" : "Failed");

			if(nError != ERR_DXI_OK)
			{
				return SNMP_ERR_GENERR;
			}
			break;
		case SNMP_VT_FLOAT:
			varValueEx.varValue.fValue = (float)lvarTemp/1000.0;
			nError = DxiSetData(VAR_A_SIGNAL_VALUE,
				nEquipId,			
				DXI_MERGE_SIG_ID(nSignalType, nSignalID),
				sizeof(VAR_VALUE_EX),
				&(varValueEx),
				0);
			AppLogOut("SNMP", APP_LOG_INFO,
				"Control EquipID=%d,SigType=%d,SigValue=%d,Value=%d,cmd executed %s!",
				nEquipId,nSignalType,nSignalID,
				lvarTemp,
				(nError == ERR_DXI_OK) ? "Successfully" : "Failed");

			if(nError != ERR_DXI_OK)
			{
				return SNMP_ERR_GENERR;
			}
			break;
		default:
			return SNMP_ERR_GENERR;
		}
		break;


	case UNDO:
		/* Back out any changes made in the ACTION case */
		break;


	case COMMIT:
		/* Things are working well, so it's now safe to make the change
		permanently.  Make sure that anything done here can't fail! */
		break;
	}
	return SNMP_ERR_NOERROR;
}


